Index: /trunk/source/Lib/TLibCommon/TComSlice.h
===================================================================
--- /trunk/source/Lib/TLibCommon/TComSlice.h	(revision 1178)
+++ /trunk/source/Lib/TLibCommon/TComSlice.h	(revision 1179)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
-* Copyright (c) 2010-2014, ITU/ISO/IEC
+* Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -914,14 +914,25 @@
   // VPS EXTENSION 2 SYNTAX ELEMENTS
 #if H_3D
+#if HHI_CAM_PARA_K0052  
+  Int*        m_numCp;  
+  Int**       m_cpRefVoi;
+  Bool**      m_cpPresentFlag; 
+  Int         m_cpPrecision;
+  Bool*       m_cpInSliceSegmentHeaderFlag;
+#else
   UInt        m_uiCamParPrecision;
   Bool*       m_bCamParInSliceHeader;
   Bool*       m_bCamParPresent;
+#endif
   Int         ***m_aaaiCodedScale ;
   Int         ***m_aaaiCodedOffset;
 
-#if HHI_VIEW_ID_LIST_I5_J0107
+#if HHI_VIEW_ID_LIST_I5_J0107 ||  HHI_INTER_COMP_PRED_K0052
   std::vector<Int>  m_viewOIdxList;
 #endif
-
+#if HHI_INTER_COMP_PRED_K0052
+  std::vector< std::vector<Bool> > m_viewCompLayerPresentFlag;
+  std::vector< std::vector<Int>  > m_viewCompLayerId;
+#endif
 #endif
 
@@ -1152,8 +1163,68 @@
   Int     getNumViews()                                                    { return m_numViews; }
   Void    initNumViews();
-#if HHI_VIEW_ID_LIST_I5_J0107
+#if HHI_INTER_COMP_PRED_K0052
+#if H_3D
+  Void   initViewCompLayer( )
+  { 
+    assert( m_viewCompLayerId.size() == 0 && m_viewCompLayerPresentFlag.size() == 0  );
+    for( Int i = 0; i < getNumViews(); i++ )
+    {
+      m_viewCompLayerId         .push_back( std::vector<Int>(0)  );
+      m_viewCompLayerPresentFlag.push_back( std::vector<Bool>(0) );      
+
+      for( Int depFlag = 0; depFlag  <=  1; depFlag++ )
+      {
+        Int iViewOIdx = getViewOIdxList( i );
+        Int layerId = -1;
+        for( Int j = 0; j  <=  getMaxLayersMinus1(); j++ ) 
+        {
+          Int jNuhLId = getLayerIdInNuh( j );
+          if( getVpsDepthFlag( jNuhLId ) == ( (Bool) depFlag )  &&  getViewOrderIdx( jNuhLId )  ==  iViewOIdx  
+            &&  getDependencyId( jNuhLId )  ==  0  &&  getAuxId( jNuhLId )  ==  0 )
+          {
+            layerId = jNuhLId;
+          }
+        }
+        m_viewCompLayerPresentFlag[ i ].push_back( layerId  !=  -1 );
+        m_viewCompLayerId         [ i ].push_back( layerId );        
+      }
+    }
+  };
+#endif
+#endif
+
+#if HHI_VIEW_ID_LIST_I5_J0107 || HHI_INTER_COMP_PRED_K0052
   Int     getViewOIdxList( Int i )                                         { return m_viewOIdxList[i]; }
-#endif
-
+#if HHI_CAM_PARA_K0052
+  std::vector<Int> getViewOIdxList( )                                               { return m_viewOIdxList; }
+#endif
+#endif
+
+#if HHI_INTER_COMP_PRED_K0052
+#if HHI_CAM_PARA_K0052
+  Int     getVoiInVps( Int viewOIdx )                                      
+#else
+  Int     getInvViewOIdxList( Int viewOIdx )                                      
+#endif
+  {    
+    for ( Int i = 0; i < m_viewOIdxList.size(); i++ )
+    {
+      if  ( m_viewOIdxList[ i ] == viewOIdx )
+      {
+        return i; 
+      }
+    }
+    assert( 0 );   
+    return -1; 
+  };
+
+#if HHI_CAM_PARA_K0052
+  Bool    getViewCompLayerPresentFlag (Int i, Bool d ) { return  m_viewCompLayerPresentFlag[ getVoiInVps(i) ][d]; }
+  Bool    getViewCompLayerId          (Int i, Bool d ) { return  m_viewCompLayerId         [ getVoiInVps(i) ][d]; }
+#else
+  Bool    getViewCompLayerPresentFlag (Int i, Bool d ) { return  m_viewCompLayerPresentFlag[ getInvViewOIdxList(i) ][d]; }
+  Bool    getViewCompLayerId          (Int i, Bool d ) { return  m_viewCompLayerId         [ getInvViewOIdxList(i) ][d]; }
+#endif
+#endif
   Bool    getDependencyFlag( Int i, Int j )                                { return m_dependencyFlag[i][j]; }
   Int     getNumDirectRefLayers( Int layerIdInNuh )                        { return m_numDirectRefLayers[ layerIdInNuh ];  };                               
@@ -1276,10 +1347,70 @@
   Void createCamPars(Int iNumViews);
   Void deleteCamPars();
+#if HHI_CAM_PARA_K0052
+  Void initCamParaVPS( Int vOIdxInVps, Int numCp, Bool cpInSliceSegmentHeaderFlag, Int* cpRefVoi, Int** aaiScale, Int** aaiOffset ); 
+#else
   Void initCamParaVPS      (  UInt uiViewIndex, Bool bCamParPresent = false, UInt uiCamParPrecision = 0, Bool bCamParSlice = false, Int** aaiScale = 0, Int** aaiOffset = 0 );
+#endif
+  
+#if HHI_CAM_PARA_K0052
+
+  Void setCpPrecision( Int  val ) { m_cpPrecision = val; } 
+  Int  getCpPrecision(  ) { return m_cpPrecision; } 
+
+  Void setNumCp( Int i, Int  val ) { m_numCp[i] = val; } 
+  Int  getNumCp( Int i )           { return m_numCp[i]; } 
+
+  Void setCpRefVoi( Int i, Int m, Int  val ) { m_cpRefVoi[i][m] = val; } 
+  Int  getCpRefVoi( Int i, Int m )           { return m_cpRefVoi[i][m]; }   
+  
+  Void setCpInSliceSegmentHeaderFlag( Int i, Bool flag ) { m_cpInSliceSegmentHeaderFlag[i] = flag; } 
+  Bool getCpInSliceSegmentHeaderFlag( Int i )            { return m_cpInSliceSegmentHeaderFlag[i]; } 
+  
+  Void setVpsCpScale( Int i, Int j, Int  val ) { m_aaaiCodedScale [i][0][j] = val; } 
+  Int  getVpsCpScale( Int i, Int j ) { return m_aaaiCodedScale[i][0][j]; } 
+
+  Void setVpsCpOff( Int i, Int j, Int  val ) { m_aaaiCodedOffset[i][0][j] = val; } 
+  Int  getVpsCpOff( Int i, Int j ) { return m_aaaiCodedOffset[i][0][j]; } 
+
+  Void setVpsCpInvScale( Int i, Int j, Int  val ) { m_aaaiCodedScale[i][1][j] = val; } 
+  Int  getVpsCpInvScale( Int i, Int j ) { return m_aaaiCodedScale[i][1][j]; } 
+
+  Void setVpsCpInvOff( Int i, Int j, Int  val ) { m_aaaiCodedOffset[i][1][j] = val; } 
+  Int  getVpsCpInvOff( Int i, Int j ) { return m_aaaiCodedOffset[i][1][j]; } 
+
+// Derived
+  Void deriveCpPresentFlag( )
+  {
+    for( Int nInVps = 0; nInVps < getNumViews(); nInVps++  )
+    {
+      for( Int mInVps = 0; mInVps < getNumViews(); mInVps++ )
+      {
+        m_cpPresentFlag[nInVps][mInVps] = 0; 
+      }
+    }
+
+   for( Int n = 1; n < getNumViews(); n++ )
+   {
+      Int iInVps = getVoiInVps(  getViewOIdxList( n ) );      
+      for( Int m = 0; m < getNumCp( iInVps ); m++ )
+      {
+         m_cpPresentFlag[ iInVps ][ getVoiInVps( getCpRefVoi( iInVps, m ) ) ] = 1;
+      }
+    }
+  }
+
+  Void setCpPresentFlag( Int i, Int m, Bool flag ) { m_cpPresentFlag[i][m] = flag; } 
+  Bool getCpPresentFlag( Int i, Int m )           { return m_cpPresentFlag[i][m]; }   
+
+#else
   UInt getCamParPrecision    ()  { return m_uiCamParPrecision; }
+
   Bool getCamParPresent      ( Int viewIndex )  { return m_bCamParPresent[viewIndex]; }
   Void setCamParPresent      ( Int viewIndex, Bool val )  { m_bCamParPresent[viewIndex] = val; }
   Bool hasCamParInSliceHeader( Int viewIndex )  { return m_bCamParInSliceHeader[viewIndex]; }
   Void setHasCamParInSliceHeader( Int viewIndex, Bool b )  { m_bCamParInSliceHeader[viewIndex] = b; }
+#endif
+
+
   Int* getCodedScale         ( Int viewIndex )  { return m_aaaiCodedScale [viewIndex][0]; }
   Int* getCodedOffset        ( Int viewIndex )  { return m_aaaiCodedOffset[viewIndex][0]; }
@@ -1574,5 +1705,9 @@
       m_qtPredFlag            [d] = false; 
       m_interSdcFlag          [d] = false; 
-      m_intraSingleFlag       [d] = false;   
+#if SEC_DEPTH_INTRA_SKIP_MODE_K0033
+      m_depthIntraSkipFlag    [d] = false;   
+#else
+      m_intraSingleFlag       [d] = false; 
+#endif
     }
   }
@@ -1617,6 +1752,11 @@
   Bool getInterSdcFlag( Int d ) { return m_interSdcFlag[d]; } 
 
+#if SEC_DEPTH_INTRA_SKIP_MODE_K0033
+  Void setDepthIntraSkipFlag( Int d, Bool flag ) { m_depthIntraSkipFlag[d] = flag; } 
+  Bool getDepthIntraSkipFlag( Int d ) { return m_depthIntraSkipFlag[d]; } 
+#else
   Void setIntraSingleFlag( Int d, Bool flag ) { m_intraSingleFlag[d] = flag; } 
   Bool getIntraSingleFlag( Int d ) { return m_intraSingleFlag[d]; } 
+#endif
 
 private:
@@ -1635,5 +1775,9 @@
   Bool        m_qtPredFlag            [2];
   Bool        m_interSdcFlag          [2];
+#if SEC_DEPTH_INTRA_SKIP_MODE_K0033
+  Bool        m_depthIntraSkipFlag    [2];  
+#else
   Bool        m_intraSingleFlag       [2];  
+#endif
 };
 
@@ -1740,6 +1884,8 @@
 #if H_3D
   TComSps3dExtension m_sps3dExtension; 
+#if !HHI_CAM_PARA_K0052
   UInt        m_uiCamParPrecision;
   Bool        m_bCamParInSliceHeader;
+#endif
   Int         m_aaiCodedScale [2][MAX_NUM_LAYERS];
   Int         m_aaiCodedOffset[2][MAX_NUM_LAYERS];
@@ -1759,6 +1905,11 @@
   Void setChromaFormatIdc (Int i)    { m_chromaFormatIdc = i;          }
 
+#if H_3D_DISABLE_CHROMA
+  static Int getWinUnitX (Int chromaFormatIdc) { assert (chromaFormatIdc >= 0 && chromaFormatIdc <= MAX_CHROMA_FORMAT_IDC); return m_winUnitX[chromaFormatIdc];      }
+  static Int getWinUnitY (Int chromaFormatIdc) { assert (chromaFormatIdc >= 0 && chromaFormatIdc <= MAX_CHROMA_FORMAT_IDC); return m_winUnitY[chromaFormatIdc];      }
+#else
   static Int getWinUnitX (Int chromaFormatIdc) { assert (chromaFormatIdc > 0 && chromaFormatIdc <= MAX_CHROMA_FORMAT_IDC); return m_winUnitX[chromaFormatIdc];      }
   static Int getWinUnitY (Int chromaFormatIdc) { assert (chromaFormatIdc > 0 && chromaFormatIdc <= MAX_CHROMA_FORMAT_IDC); return m_winUnitY[chromaFormatIdc];      }
+#endif
   
   // structure
@@ -2366,4 +2517,7 @@
   UInt                 m_nARPStepNum; 
   Int         m_aiFirstTRefIdx    [2]; 
+#if HHI_RES_PRED_K0052
+  std::vector<Int> m_pocsInCurrRPSs; 
+#endif
 #endif
 #if H_3D_IC
@@ -2372,4 +2526,13 @@
 #endif
 #if H_3D
+#if HHI_INTER_COMP_PRED_K0052
+  std::vector<Int> m_inCmpRefViewIdcs;
+  Bool       m_inCmpPredAvailFlag; 
+  Bool       m_inCmpPredFlag; 
+#endif
+#if HHI_CAM_PARA_K0052
+  Bool       m_cpAvailableFlag; 
+  Int        m_numViews; 
+#endif
   TComPic*   m_ivPicsCurrPoc [2][MAX_NUM_LAYERS];  
   Int**      m_depthToDisparityB; 
@@ -2377,6 +2540,10 @@
 #endif
 #endif
+#if SEC_DEPTH_INTRA_SKIP_MODE_K0033
+  Bool      m_bApplyDIS;
+#else
 #if H_3D_SINGLE_DEPTH
   Bool      m_bApplySingleDepthMode;
+#endif
 #endif
 #if H_3D_IC
@@ -2398,6 +2565,9 @@
   Bool m_qtPredFlag           ;
   Bool m_interSdcFlag         ;
+#if SEC_DEPTH_INTRA_SKIP_MODE_K0033
+  Bool m_depthIntraSkipFlag   ;
+#else
   Bool m_intraSingleFlag      ;
-
+#endif
   Int  m_mpiSubPbSize         ; 
   Int  m_subPbSize            ; 
@@ -2467,4 +2637,14 @@
   Int       getRefPOC           ( RefPicList e, Int iRefIdx)    { return  m_aiRefPOCList[e][iRefIdx];   }
 #if H_3D
+#if HHI_INTER_COMP_PRED_K0052
+  Bool      getInCmpPredAvailFlag( )                             { return m_inCmpPredAvailFlag;    } 
+#if HHI_CAM_PARA_K0052
+  Bool      getCpAvailableFlag( )                             { return m_cpAvailableFlag;    } 
+#endif
+  Bool      getInCompPredFlag( )                                 { return m_inCmpPredFlag;         }    
+  Void      setInCompPredFlag( Bool b )                          { m_inCmpPredFlag = b;            }    
+  Int       getInCmpRefViewIdcs( Int i )                         { return m_inCmpRefViewIdcs  [i]; }
+  Int       getNumCurCmpLIds( )                                  { return (Int) m_inCmpRefViewIdcs.size(); } 
+#endif
   TComPic*  getIvPic            ( Bool depthFlag, Int viewIndex){ return  m_ivPicsCurrPoc[ depthFlag ? 1 : 0 ][ viewIndex ]; }
 #endif
@@ -2568,4 +2748,7 @@
   UInt getTLayer             ()                            { return m_uiTLayer;                      }
   Void setTLayer             ( UInt uiTLayer )             { m_uiTLayer = uiTLayer;                  }
+#if H_MV
+  Int getTemporalId          ( )                           { return (Int) m_uiTLayer;                }
+#endif
 
   Void setTLayerInfo( UInt uiTLayer );
@@ -2692,4 +2875,7 @@
   Void      setFirstTRefIdx        ( RefPicList e, Int i )         { m_aiFirstTRefIdx[e]    = i;      }
   Bool      getArpRefPicAvailable( RefPicList e, Int viewIdx) {return m_arpRefPicAvailable[e][getVPS()->getLayerIdInNuh(viewIdx, 0)]; }
+#if HHI_RES_PRED_K0052
+  std::vector<Int> getPocsInCurrRPSs()                             { return m_pocsInCurrRPSs; }; 
+#endif
 #endif
   Void      setIsDepth            ( Bool isDepth )   { m_isDepth = isDepth; }
@@ -2700,4 +2886,18 @@
   Int*      getInvCodedScale      ()  { return m_aaiCodedScale [1]; }
   Int*      getInvCodedOffset     ()  { return m_aaiCodedOffset[1]; }
+#if HHI_CAM_PARA_K0052
+  Void      setCpScale( Int j, Int  val ) { m_aaiCodedScale[0][j] = val; } 
+  Int       getCpScale( Int j ) { return m_aaiCodedScale[0][j]; } 
+            
+  Void      setCpOff( Int j, Int  val ) { m_aaiCodedOffset[0][j] = val; } 
+  Int       getCpOff( Int j ) { return m_aaiCodedOffset[0][j]; } 
+            
+  Void      setCpInvScale( Int j, Int  val ) { m_aaiCodedScale[1][j] = val; } 
+  Int       getCpInvScale( Int j ) { return m_aaiCodedScale[1][j]; } 
+            
+  Void      setCpInvOff( Int j, Int  val ) { m_aaiCodedOffset[1][j] = val; } 
+  Int       getCpInvOff( Int j ) { return m_aaiCodedOffset[1][j]; } 
+#endif
+
 #endif
 #endif
@@ -2706,6 +2906,11 @@
   Void    setDepthToDisparityLUTs();
 
+#if HHI_CAM_PARA_K0052
+  Int* getDepthToDisparityB( Int refViewIdx ) { return m_depthToDisparityB[ getVPS()->getVoiInVps( refViewIdx) ]; }; 
+  Int* getDepthToDisparityF( Int refViewIdx ) { return m_depthToDisparityF[ getVPS()->getVoiInVps( refViewIdx) ]; }; 
+#else
   Int* getDepthToDisparityB( Int refViewIdx ) { return m_depthToDisparityB[ refViewIdx ]; }; 
   Int* getDepthToDisparityF( Int refViewIdx ) { return m_depthToDisparityF[ refViewIdx ]; }; 
+#endif
 #endif
 #if H_3D_IC
@@ -2810,5 +3015,95 @@
 #if H_3D
   // 3D-HEVC tool parameters
+#if HHI_INTER_COMP_PRED_K0052
+  Void deriveInCmpPredAndCpAvailFlag()
+  { 
+    Int numCurCmpLIds = getIsDepth() ? 1 : getNumActiveRefLayerPics(); 
+    std::vector<Int> curCmpLIds;
+    if ( getIsDepth() )
+    {
+      curCmpLIds.push_back( getLayerId() );
+    }
+    else
+    {
+      for (Int i = 0; i < numCurCmpLIds; i++)
+      {
+        curCmpLIds.push_back( getRefPicLayerId( i ) );
+      }
+    }
+
+#if HHI_CAM_PARA_K0052
+    m_cpAvailableFlag = true;
+    m_inCmpRefViewIdcs.clear();
+#endif
+    Bool allRefCmpLayersAvailFlag = true;
+
+    for( Int i = 0; i <= numCurCmpLIds - 1; i++ )
+    {      
+      m_inCmpRefViewIdcs.push_back( getVPS()->getViewOrderIdx( curCmpLIds[ i ] ));
+#if HHI_CAM_PARA_K0052
+      if( !getVPS()->getCpPresentFlag( getVPS()->getVoiInVps( getViewIndex() ),  getVPS()->getVoiInVps( m_inCmpRefViewIdcs[ i ] ) ) )
+      {
+        m_cpAvailableFlag = false;
+      }
+#endif
+      Bool refCmpCurLIdAvailFlag = false;
+      if( getVPS()->getViewCompLayerPresentFlag( m_inCmpRefViewIdcs[ i ], !getIsDepth() ) )
+      {
+        Int j = getVPS()->getLayerIdInVps( getVPS()->getViewCompLayerId( m_inCmpRefViewIdcs[ i ],  !getIsDepth() ) );
+        if  ( getVPS()->getDirectDependencyFlag( getVPS()->getLayerIdInVps( getLayerId() ) ,  j ) &&
+          getVPS()->getSubLayersVpsMaxMinus1( j ) >= getTemporalId()   &&
+          ( getTemporalId() == 0 || getVPS()->getMaxTidIlRefPicsPlus1( j , getVPS()->getLayerIdInVps( getLayerId() ) ) > getTemporalId() )        
+          )
+        {
+          refCmpCurLIdAvailFlag = true;
+        }
+      }
+      if( !refCmpCurLIdAvailFlag )
+      {
+        allRefCmpLayersAvailFlag = false;
+      }
+    }
+
+    if( !allRefCmpLayersAvailFlag )
+    {
+      m_inCmpPredAvailFlag = false;
+    }  
+    else 
+    {
+      TComSps3dExtension* sps3dExt = getSPS()->getSps3dExtension();
+      if( !getIsDepth() )
+      {
+        m_inCmpPredAvailFlag = sps3dExt->getViewSynthesisPredFlag( getIsDepth() ) || 
+          sps3dExt->getDepthBasedBlkPartFlag( getIsDepth() ) || 
+          sps3dExt->getDepthRefinementFlag  ( getIsDepth() );                            
+      }
+      else
+      {
+        m_inCmpPredAvailFlag = sps3dExt->getIntraContourFlag( getIsDepth() ) || 
+          sps3dExt->getQtPredFlag( getIsDepth() ) || 
+          sps3dExt->getMpiFlag( getIsDepth() );                                  
+      }
+    }  
+  };
+
+#endif
+
   Void init3dToolParameters();   
+#if HHI_INTER_COMP_PRED_K0052
+  Void checkInCompPredRefLayers()
+  {
+    if ( getInCompPredFlag() )
+    {
+      for (Int i = 0; i < getNumCurCmpLIds(); i++ )
+      {
+        assert( getIvPic(!getIsDepth(), getInCmpRefViewIdcs( i ) ) != NULL );       
+        //  It is a requirement of bitstream conformance that there 
+        //  is a picture in the DPB with PicOrderCntVal equal to the PicOrderCntVal of the current picture, 
+        //  and a nuh_layer_id value equal to ViewCompLayerId[ inCmpRefViewIdcs[ i ] ][ !DepthFlag ].
+      }
+    }
+  };
+
+#endif
   Bool getIvMvPredFlag           ( ) { return m_ivMvPredFlag           ; };
   Bool getIvMvScalingFlag        ( ) { return m_ivMvScalingFlag        ; };
@@ -2822,5 +3117,9 @@
   Bool getQtPredFlag             ( ) { return m_qtPredFlag             ; };
   Bool getInterSdcFlag           ( ) { return m_interSdcFlag           ; };
+#if SEC_DEPTH_INTRA_SKIP_MODE_K0033
+  Bool getDepthIntraSkipFlag     ( ) { return m_depthIntraSkipFlag     ; };
+#else
   Bool getIntraSingleFlag        ( ) { return m_intraSingleFlag        ; };
+#endif
 
   Int  getMpiSubPbSize           ( ) { return m_mpiSubPbSize           ; }; 
Index: /trunk/source/Lib/TLibCommon/TComTrQuant.cpp
===================================================================
--- /trunk/source/Lib/TLibCommon/TComTrQuant.cpp	(revision 1178)
+++ /trunk/source/Lib/TLibCommon/TComTrQuant.cpp	(revision 1179)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
-* Copyright (c) 2010-2014, ITU/ISO/IEC
+* Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
Index: /trunk/source/Lib/TLibCommon/TComTrQuant.h
===================================================================
--- /trunk/source/Lib/TLibCommon/TComTrQuant.h	(revision 1178)
+++ /trunk/source/Lib/TLibCommon/TComTrQuant.h	(revision 1179)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
-* Copyright (c) 2010-2014, ITU/ISO/IEC
+* Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
Index: /trunk/source/Lib/TLibCommon/TComWedgelet.cpp
===================================================================
--- /trunk/source/Lib/TLibCommon/TComWedgelet.cpp	(revision 1178)
+++ /trunk/source/Lib/TLibCommon/TComWedgelet.cpp	(revision 1179)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2011, ISO/IEC
+ * Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -177,4 +177,39 @@
 }
 
+#if SHARP_DMM_CLEAN_K0042
+Void TComWedgelet::generateWedgePatternByRotate(const TComWedgelet &rcWedge, Int rotate)
+{
+  Int stride = m_uiWidth;
+  Int sinc, offsetI, offsetJ;
+  
+  sinc = 1;
+  offsetI = ( sinc) < 0 ? stride-1 : 0; // 0
+  offsetJ = (-sinc) < 0 ? stride-1 : 0; // stride - 1
+
+  for (Int y = 0; y < stride; y++)
+  {
+    for (Int x = 0; x < stride; x++)
+    {
+      Int i = offsetI + sinc * y; // y
+      Int j = offsetJ - sinc * x; // stride - 1 - x
+      m_pbPattern[(y * stride) + x] = !rcWedge.m_pbPattern[(j * stride) + i];
+    }
+  }
+  Int blocksize = rcWedge.m_uiWidth * (rcWedge.m_eWedgeRes == HALF_PEL ? 2 : 1);
+  Int offsetX = (-sinc) < 0 ? blocksize - 1 : 0;
+  Int offsetY = ( sinc) < 0 ? blocksize - 1 : 0;
+  m_uhXs = offsetX - sinc * rcWedge.m_uhYs;
+  m_uhYs = offsetY + sinc * rcWedge.m_uhXs;
+  m_uhXe = offsetX - sinc * rcWedge.m_uhYe;
+  m_uhYe = offsetY + sinc * rcWedge.m_uhXe;
+  m_uhOri = rotate;
+  m_eWedgeRes = rcWedge.m_eWedgeRes;
+  m_bIsCoarse = rcWedge.m_bIsCoarse;
+  m_uiAng = rcWedge.m_uiAng;
+  m_uiWidth  = rcWedge.m_uiWidth;
+  m_uiHeight = rcWedge.m_uiHeight;
+}
+#endif
+
 Void TComWedgelet::xGenerateWedgePattern()
 {
@@ -193,4 +228,19 @@
   xDrawEdgeLine( uhXs, uhYs, uhXe, uhYe, pbTempPattern, iTempStride );
 
+#if SHARP_DMM_CLEAN_K0042
+  Int shift = (m_eWedgeRes == HALF_PEL) ? 1 : 0;
+  Int endPos = uhYe>>shift;
+  for (Int y = 0; y <= endPos; y++)
+  {
+    for (Int x = 0; x < m_uiWidth && pbTempPattern[(y * m_uiWidth) + x] == 0; x++)
+    {
+      pbTempPattern[(y * m_uiWidth) + x] = true;
+    }
+  }
+  for( UInt k = 0; k < (m_uiWidth * m_uiHeight); k++ )
+  {
+    m_pbPattern[k] = pbTempPattern[k];
+  };
+#else
   switch( m_uhOri )
   {
@@ -252,4 +302,5 @@
     break;
   }
+#endif
 
   if( pbTempPattern )
@@ -294,6 +345,13 @@
   for( Int x = x0; x <= x1; x++ )
   {
+#if SHARP_DMM_CLEAN_K0042
+    Int shift = (m_eWedgeRes == HALF_PEL) ? 1 : 0;
+    Int stride = iPatternStride >> shift;
+    if( steep ) { pbPattern[((x>>shift) * stride) + (y>>shift)] = true; }
+    else        { pbPattern[((y>>shift) * stride) + (x>>shift)] = true; }
+#else
     if( steep ) { pbPattern[(x * iPatternStride) + y] = true; }
     else        { pbPattern[(y * iPatternStride) + x] = true; }
+#endif
 
     error += deltaerr;
Index: /trunk/source/Lib/TLibCommon/TComWedgelet.h
===================================================================
--- /trunk/source/Lib/TLibCommon/TComWedgelet.h	(revision 1178)
+++ /trunk/source/Lib/TLibCommon/TComWedgelet.h	(revision 1179)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
- * Copyright (c) 2010-2011, ISO/IEC
+ * Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -124,4 +124,7 @@
   Bool*           getScaledPattern(UInt uiWidth);
 
+#if SHARP_DMM_CLEAN_K0042
+  Void  generateWedgePatternByRotate(const TComWedgelet &rcWedge, Int rotate);
+#endif
   Void  setWedgelet( UChar uhXs, UChar uhYs, UChar uhXe, UChar uhYe, UChar uhOri, WedgeResolution eWedgeRes, Bool bIsCoarse = false );
   Void  findClosestAngle();
Index: /trunk/source/Lib/TLibCommon/TComWeightPrediction.cpp
===================================================================
--- /trunk/source/Lib/TLibCommon/TComWeightPrediction.cpp	(revision 1178)
+++ /trunk/source/Lib/TLibCommon/TComWeightPrediction.cpp	(revision 1179)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
-* Copyright (c) 2010-2014, ITU/ISO/IEC
+* Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
Index: /trunk/source/Lib/TLibCommon/TComWeightPrediction.h
===================================================================
--- /trunk/source/Lib/TLibCommon/TComWeightPrediction.h	(revision 1178)
+++ /trunk/source/Lib/TLibCommon/TComWeightPrediction.h	(revision 1179)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
-* Copyright (c) 2010-2014, ITU/ISO/IEC
+* Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
Index: /trunk/source/Lib/TLibCommon/TComYuv.cpp
===================================================================
--- /trunk/source/Lib/TLibCommon/TComYuv.cpp	(revision 1178)
+++ /trunk/source/Lib/TLibCommon/TComYuv.cpp	(revision 1179)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
-* Copyright (c) 2010-2014, ITU/ISO/IEC
+* Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
Index: /trunk/source/Lib/TLibCommon/TComYuv.h
===================================================================
--- /trunk/source/Lib/TLibCommon/TComYuv.h	(revision 1178)
+++ /trunk/source/Lib/TLibCommon/TComYuv.h	(revision 1179)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
-* Copyright (c) 2010-2014, ITU/ISO/IEC
+* Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
Index: /trunk/source/Lib/TLibCommon/TypeDef.h
===================================================================
--- /trunk/source/Lib/TLibCommon/TypeDef.h	(revision 1178)
+++ /trunk/source/Lib/TLibCommon/TypeDef.h	(revision 1179)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
-* Copyright (c) 2010-2014, ITU/ISO/IEC
+* Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -65,8 +65,15 @@
 #define H_3D          ( HEVC_EXT == 2)
 
+#if H_MV
+#define SONY_MV_V_CONST_C0078            1   // Control disparity vector search range via configuration file
+#define H_MV_FIX_CONF_WINDOW             1   
+#endif
+
 #define NTT_BUG_FIX_TK54    1
 #define BUG_FIX_TK65        1
 
 #define MTK_I0093           1
+
+#define RWTH_DBBP_NO_SATD_K0028       1
 /////////////////////////////////////////////////////////////////////////////////////////
 ///////////////////////////////////   MAJOR DEFINES   ///////////////////////////////////  
@@ -78,4 +85,11 @@
 
 #if H_3D
+#define SEC_DEPTH_INTRA_SKIP_MODE_K0033   1   // Depth intra skip mode
+
+#if SEC_DEPTH_INTRA_SKIP_MODE_K0033
+#define NEIGHBORING_PIX_AVAILABILITY_FIX  1
+#endif
+
+
 #define H_3D_QTLPC                        1   // OL_QTLIMIT_PREDCODING_B0068 //JCT3V-B0068
                                               // HHI_QTLPC_RAU_OFF_C0160 JCT3V-C0160 change 2: quadtree limitation and predictive coding switched off in random access units 
@@ -117,4 +131,6 @@
 #define SEC_ARP_VIEW_REF_CHECK_J0037      1   // Signaling iv_res_pred_weight_idx when the current slice has both view and temporal reference picture(s), JCT3V-J0037 item1
 
+#define SEC_ARP_REM_ENC_RESTRICT_K0035    1   // Removal of encoder restriction of ARP, JCT3V-K0035
+
 #define H_3D_IC                           1   // Illumination Compensation, JCT3V-B0045, JCT3V-C0046, JCT3V-D0060
                                               // Unifying rounding offset, for IC part, JCT3V-D0135
@@ -185,9 +201,12 @@
                                               // SEC_SIMP_SHIFTED_DV_I0086     Simplification of Shifted DV candidate, JCT3V-I0086
 
-
+#define SEC_SHIFTED_IVMC_POS_K0036        1   // Position Derivation for Shifted-IVMC, JCT3V-K0036
 
 
 #define H_3D_TMVP                         1   // QC_TMVP_C0047 
                                               // Sony_M23639
+#if H_3D_TMVP
+#define H_3D_TMVP_SCALING_FIX_K0053       1   // QC/CY for K0053
+#endif
 
 #define H_3D_DIM                          1   // DIM, Depth intra modes, includes:
@@ -239,8 +258,10 @@
                                               // SHARP_DLT_SIMP_J0029              1   // DLT(DepthValue2Idx[]) table derivation cleanup
 
+#if !SEC_DEPTH_INTRA_SKIP_MODE_K0033
 #define H_3D_SINGLE_DEPTH                 1   // Single depth mode proposed in JCT3V-I0095
                                               // HS_SP_SIMP_J0066
                                               // SINGLE_DEPTH_SIMP_J0115           1 
                                               // MTK_SINGLE_DEPTH_VPS_FLAG_J0060   1   // Add VPS control flags and remove slice header control flag for single depth, JCT3V-J0060
+#endif
 
 #define H_3D_INTER_SDC                    1   // INTER SDC, Inter simplified depth coding
@@ -265,4 +286,5 @@
                                               // SEC_DBBP_DMM4_THRESHOLD_I0076     Simplification of threshold derivation for DBBP and DMM4, JCT3V-I0076
                                               // SEC_DBBP_VIEW_REF_CHECK_J0037     1   // Signaling dbbp_flag when the current slice has view reference picture(s), JCT3V-J0037 item4
+#define HS_DBBP_CLEAN_K0048     1 
 
 #define H_3D_DDD                          1   // Disparity derived depth coding
@@ -305,7 +327,17 @@
 // Fixes
 
+#define FIX_TICKET_95                          1   // pps_scaling_list_ref_layer_id parsing
 
 #if H_3D
+#define H_3D_DISABLE_CHROMA                    1 
 #define HHI_VIEW_ID_LIST_I5_J0107              0
+#define HHI_INTER_COMP_PRED_K0052              1
+#define HHI_RES_PRED_K0052                     1
+#define HHI_CAM_PARA_K0052                     1
+#define HHI_MOVE_SYN_K0052                     1
+#define H_3D_ANNEX_SELECTION_FIX               1
+#define H_3D_TMVP_FIX_TICKET_97                1
+#define H_3D_DIRECT_DEP_TYPE                   1
+#define H_3D_FIX_TMVP_SCALING_VIEW_ID          1
 #endif
 #define H_MV_FIX_REF_LAYER_PIC_FLAG            1
@@ -313,8 +345,10 @@
 #define H_3D_OUTPUT_ACTIVE_TOOLS               0
 
+#if !SEC_DEPTH_INTRA_SKIP_MODE_K0033
 ///// ***** SINGLE DEPTH MODE *********
 #if H_3D_SINGLE_DEPTH
 #define SINGLE_DEPTH_MODE_CAND_LIST_SIZE            2 // size of the sample candidate list
 
+#endif
 #endif
 
@@ -350,6 +384,9 @@
                                               // HHI_DEPTH_INTRA_SEARCH_RAU_C0160
                                               // LG_ZEROINTRADEPTHRESI_A0087
+#define SHARP_DMM_CLEAN_K0042             1   // Generate DMM pattern with rotation 
 
 #define TICKET083_IVPFLAG_FIX             1
+#define SHARP_SUBBLOCK_CLEAN_K0044        1   // Remove unused bipred restriction
+
 #endif
 ///// ***** VIEW SYNTHESIS PREDICTION *********
Index: /trunk/source/Lib/TLibDecoder/AnnexBread.cpp
===================================================================
--- /trunk/source/Lib/TLibDecoder/AnnexBread.cpp	(revision 1178)
+++ /trunk/source/Lib/TLibDecoder/AnnexBread.cpp	(revision 1179)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
-* Copyright (c) 2010-2014, ITU/ISO/IEC
+* Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
Index: /trunk/source/Lib/TLibDecoder/AnnexBread.h
===================================================================
--- /trunk/source/Lib/TLibDecoder/AnnexBread.h	(revision 1178)
+++ /trunk/source/Lib/TLibDecoder/AnnexBread.h	(revision 1179)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
-* Copyright (c) 2010-2014, ITU/ISO/IEC
+* Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
Index: /trunk/source/Lib/TLibDecoder/NALread.cpp
===================================================================
--- /trunk/source/Lib/TLibDecoder/NALread.cpp	(revision 1178)
+++ /trunk/source/Lib/TLibDecoder/NALread.cpp	(revision 1179)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
-* Copyright (c) 2010-2014, ITU/ISO/IEC
+* Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
Index: /trunk/source/Lib/TLibDecoder/NALread.h
===================================================================
--- /trunk/source/Lib/TLibDecoder/NALread.h	(revision 1178)
+++ /trunk/source/Lib/TLibDecoder/NALread.h	(revision 1179)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
-* Copyright (c) 2010-2014, ITU/ISO/IEC
+* Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
Index: /trunk/source/Lib/TLibDecoder/SEIread.cpp
===================================================================
--- /trunk/source/Lib/TLibDecoder/SEIread.cpp	(revision 1178)
+++ /trunk/source/Lib/TLibDecoder/SEIread.cpp	(revision 1179)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
-* Copyright (c) 2010-2014, ITU/ISO/IEC
+* Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
Index: /trunk/source/Lib/TLibDecoder/SEIread.h
===================================================================
--- /trunk/source/Lib/TLibDecoder/SEIread.h	(revision 1178)
+++ /trunk/source/Lib/TLibDecoder/SEIread.h	(revision 1179)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
-* Copyright (c) 2010-2014, ITU/ISO/IEC
+* Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
